From a1a2138b35c26c0bfd4fa31223c8069f1a996268 Mon Sep 17 00:00:00 2001
From: Pavan Deolasee <pavan.deolasee@gmail.com>
Date: Tue, 27 Nov 2018 16:43:15 +0530
Subject: [PATCH] MERGE SQL Command following SQL:2016

    MERGE performs actions that modify rows in the target table
    using a source table or query. MERGE provides a single SQL
    statement that can conditionally INSERT/UPDATE/DELETE rows
    a task that would other require multiple PL statements.
    e.g.

    MERGE INTO target AS t
    USING source AS s
    ON t.tid = s.sid
    WHEN MATCHED AND t.balance > s.delta THEN
      UPDATE SET balance = t.balance - s.delta
    WHEN MATCHED THEN
      DELETE
    WHEN NOT MATCHED AND s.delta > 0 THEN
      INSERT VALUES (s.sid, s.delta)
    WHEN NOT MATCHED THEN
      DO NOTHING;

    MERGE works with regular and partitioned tables, including
    column and row security enforcement, as well as support for
    row, statement and transition triggers.

    MERGE is optimized for OLTP and is parameterizable, though
    also useful for large scale ETL/ELT. MERGE is not intended
    to be used in preference to existing single SQL commands
    for INSERT, UPDATE or DELETE since there is some overhead.
    MERGE can be used statically from PL/pgSQL.

    MERGE does not yet support inheritance, write rules,
    RETURNING clauses, updatable views or foreign tables.
    MERGE follows SQL Standard per the most recent SQL:2016.

    Includes full tests and documentation, including full
    isolation tests to demonstrate the concurrent behavior.

    This version written from scratch in 2017 by Simon Riggs,
	using docs and tests originally written in 2009. Later work
    from Pavan Deolasee has been both complex and deep, leaving
    the lead author credit now in his hands.
    Extensive discussion of concurrency from Peter Geoghegan,
    with thanks for the time and effort contributed.

    Various issues reported via sqlsmith by Andreas Seltenreich

    Authors: Pavan Deolasee, Simon Riggs
    Reviewer: Peter Geoghegan, Amit Langote, Tomas Vondra, Simon Riggs

    Discussion:
    https://postgr.es/m/CANP8+jKitBSrB7oTgT9CY2i1ObfOt36z0XMraQc+Xrz8QB0nXA@mail.gmail.com
    https://postgr.es/m/CAH2-WzkJdBuxj9PO=2QaO9-3h3xGbQPZ34kJH=HukRekwM-GZg@mail.gmail.com
---
 contrib/test_decoding/expected/ddl.out             |   46 +
 contrib/test_decoding/sql/ddl.sql                  |   16 +
 doc/src/sgml/libpq.sgml                            |    8 +-
 doc/src/sgml/mvcc.sgml                             |   28 +-
 doc/src/sgml/plpgsql.sgml                          |    3 +-
 doc/src/sgml/ref/allfiles.sgml                     |    1 +
 doc/src/sgml/ref/create_policy.sgml                |    7 +
 doc/src/sgml/ref/insert.sgml                       |   11 +-
 doc/src/sgml/ref/merge.sgml                        |  617 ++++++++
 doc/src/sgml/reference.sgml                        |    1 +
 doc/src/sgml/trigger.sgml                          |   20 +
 src/backend/access/heap/heapam.c                   |   28 +-
 src/backend/catalog/sql_features.txt               |    6 +-
 src/backend/commands/explain.c                     |   37 +-
 src/backend/commands/prepare.c                     |    1 +
 src/backend/commands/trigger.c                     |  262 +++-
 src/backend/executor/Makefile                      |    2 +-
 src/backend/executor/README                        |   11 +
 src/backend/executor/execMain.c                    |   17 +
 src/backend/executor/execMerge.c                   |  679 ++++++++
 src/backend/executor/execPartition.c               |  279 +++-
 src/backend/executor/execReplication.c             |    5 +-
 src/backend/executor/instrument.c                  |    4 +-
 src/backend/executor/nodeIndexonlyscan.c           |    2 +-
 src/backend/executor/nodeModifyTable.c             |  298 +++-
 src/backend/executor/spi.c                         |    3 +
 src/backend/nodes/copyfuncs.c                      |   58 +
 src/backend/nodes/equalfuncs.c                     |   49 +
 src/backend/nodes/nodeFuncs.c                      |   64 +-
 src/backend/nodes/outfuncs.c                       |   40 +
 src/backend/nodes/readfuncs.c                      |   45 +
 src/backend/optimizer/plan/createplan.c            |   20 +-
 src/backend/optimizer/plan/planner.c               |   29 +-
 src/backend/optimizer/plan/setrefs.c               |   54 +
 src/backend/optimizer/prep/preptlist.c             |   41 +
 src/backend/optimizer/util/pathnode.c              |   11 +-
 src/backend/optimizer/util/plancat.c               |    4 +
 src/backend/parser/Makefile                        |    2 +-
 src/backend/parser/analyze.c                       |   18 +-
 src/backend/parser/gram.y                          |  151 +-
 src/backend/parser/parse_agg.c                     |   10 +
 src/backend/parser/parse_clause.c                  |   57 +-
 src/backend/parser/parse_collate.c                 |    1 +
 src/backend/parser/parse_expr.c                    |    3 +
 src/backend/parser/parse_func.c                    |    3 +
 src/backend/parser/parse_merge.c                   |  654 ++++++++
 src/backend/parser/parse_relation.c                |   10 +
 src/backend/rewrite/rewriteHandler.c               |  115 +-
 src/backend/rewrite/rowsecurity.c                  |   97 ++
 src/backend/tcop/pquery.c                          |    5 +
 src/backend/tcop/utility.c                         |   16 +
 src/bin/psql/tab-complete.c                        |   79 +-
 src/include/access/heapam.h                        |   13 +-
 src/include/commands/trigger.h                     |    6 +-
 src/include/executor/execMerge.h                   |   31 +
 src/include/executor/execPartition.h               |    5 +
 src/include/executor/instrument.h                  |    5 +-
 src/include/executor/nodeModifyTable.h             |   24 +
 src/include/executor/spi.h                         |    1 +
 src/include/nodes/execnodes.h                      |   75 +-
 src/include/nodes/nodes.h                          |    7 +-
 src/include/nodes/parsenodes.h                     |   53 +-
 src/include/nodes/plannodes.h                      |    8 +-
 src/include/nodes/relation.h                       |    7 +-
 src/include/optimizer/pathnode.h                   |    7 +-
 src/include/parser/analyze.h                       |    5 +
 src/include/parser/kwlist.h                        |    2 +
 src/include/parser/parse_clause.h                  |    5 +-
 src/include/parser/parse_merge.h                   |   19 +
 src/include/parser/parse_node.h                    |    5 +-
 src/include/rewrite/rewriteHandler.h               |    1 +
 src/interfaces/libpq/fe-exec.c                     |    9 +-
 src/pl/plpgsql/src/pl_exec.c                       |    7 +-
 src/pl/plpgsql/src/pl_gram.y                       |    8 +
 src/pl/plpgsql/src/pl_scanner.c                    |    1 +
 src/pl/plpgsql/src/plpgsql.h                       |    4 +-
 src/test/isolation/expected/merge-delete.out       |   97 ++
 .../isolation/expected/merge-insert-update.out     |   84 +
 .../isolation/expected/merge-match-recheck.out     |  106 ++
 src/test/isolation/expected/merge-update.out       |  238 +++
 src/test/isolation/isolation_schedule              |    4 +
 src/test/isolation/specs/merge-delete.spec         |   51 +
 src/test/isolation/specs/merge-insert-update.spec  |   52 +
 src/test/isolation/specs/merge-match-recheck.spec  |   79 +
 src/test/isolation/specs/merge-update.spec         |  133 ++
 src/test/regress/expected/identity.out             |   55 +
 src/test/regress/expected/merge.out                | 1655 ++++++++++++++++++++
 src/test/regress/expected/privileges.out           |   98 ++
 src/test/regress/expected/rowsecurity.out          |  182 +++
 src/test/regress/expected/rules.out                |   31 +
 src/test/regress/expected/triggers.out             |   48 +
 src/test/regress/expected/with.out                 |  137 ++
 src/test/regress/parallel_schedule                 |    2 +-
 src/test/regress/serial_schedule                   |    1 +
 src/test/regress/sql/identity.sql                  |   45 +
 src/test/regress/sql/merge.sql                     | 1165 ++++++++++++++
 src/test/regress/sql/privileges.sql                |  108 ++
 src/test/regress/sql/rowsecurity.sql               |  156 ++
 src/test/regress/sql/rules.sql                     |   33 +
 src/test/regress/sql/triggers.sql                  |   47 +
 src/test/regress/sql/with.sql                      |   56 +
 src/tools/pgindent/typedefs.list                   |    3 +
 102 files changed, 8779 insertions(+), 223 deletions(-)
 create mode 100644 doc/src/sgml/ref/merge.sgml
 create mode 100644 src/backend/executor/execMerge.c
 create mode 100644 src/backend/parser/parse_merge.c
 create mode 100644 src/include/executor/execMerge.h
 create mode 100644 src/include/parser/parse_merge.h
 create mode 100644 src/test/isolation/expected/merge-delete.out
 create mode 100644 src/test/isolation/expected/merge-insert-update.out
 create mode 100644 src/test/isolation/expected/merge-match-recheck.out
 create mode 100644 src/test/isolation/expected/merge-update.out
 create mode 100644 src/test/isolation/specs/merge-delete.spec
 create mode 100644 src/test/isolation/specs/merge-insert-update.spec
 create mode 100644 src/test/isolation/specs/merge-match-recheck.spec
 create mode 100644 src/test/isolation/specs/merge-update.spec
 create mode 100644 src/test/regress/expected/merge.out
 create mode 100644 src/test/regress/sql/merge.sql

diff --git a/contrib/test_decoding/sql/ddl.sql b/contrib/test_decoding/sql/ddl.sql
index c4b10a4cf9..0e608b252f 100644
--- a/contrib/test_decoding/sql/ddl.sql
+++ b/contrib/test_decoding/sql/ddl.sql
@@ -93,6 +93,22 @@ COMMIT;
 /* display results */
 SELECT data FROM pg_logical_slot_get_changes('regression_slot', NULL, NULL, 'include-xids', '0', 'skip-empty-xacts', '1');
 
+-- MERGE support
+BEGIN;
+MERGE INTO replication_example t
+	USING (SELECT i as id, i as data, i as num FROM generate_series(-20, 5) i) s
+	ON t.id = s.id
+	WHEN MATCHED AND t.id < 0 THEN
+		UPDATE SET somenum = somenum + 1
+	WHEN MATCHED AND t.id >= 0 THEN
+		DELETE
+	WHEN NOT MATCHED THEN
+		INSERT VALUES (s.*);
+COMMIT;
+
+/* display results */
+SELECT data FROM pg_logical_slot_get_changes('regression_slot', NULL, NULL, 'include-xids', '0', 'skip-empty-xacts', '1');
+
 CREATE TABLE tr_unique(id2 serial unique NOT NULL, data int);
 INSERT INTO tr_unique(data) VALUES(10);
 ALTER TABLE tr_unique RENAME TO tr_pkey;
diff --git a/doc/src/sgml/libpq.sgml b/doc/src/sgml/libpq.sgml
index d2e5b08541..38303c0262 100644
--- a/doc/src/sgml/libpq.sgml
+++ b/doc/src/sgml/libpq.sgml
@@ -3954,9 +3954,11 @@ char *PQcmdTuples(PGresult *res);
        <structname>PGresult</structname>. This function can only be used following
        the execution of a <command>SELECT</command>, <command>CREATE TABLE AS</command>,
        <command>INSERT</command>, <command>UPDATE</command>, <command>DELETE</command>,
-       <command>MOVE</command>, <command>FETCH</command>, or <command>COPY</command> statement,
-       or an <command>EXECUTE</command> of a prepared query that contains an
-       <command>INSERT</command>, <command>UPDATE</command>, or <command>DELETE</command> statement.
+       <command>MERGE</command>, <command>MOVE</command>, <command>FETCH</command>,
+       or <command>COPY</command> statement, or an <command>EXECUTE</command> of a
+       prepared query that contains an <command>INSERT</command>,
+       <command>UPDATE</command>, <command>DELETE</command>
+       or <command>MERGE</command> statement.
        If the command that generated the <structname>PGresult</structname> was anything
        else, <function>PQcmdTuples</function> returns an empty string. The caller
        should not free the return value directly. It will be freed when
diff --git a/doc/src/sgml/mvcc.sgml b/doc/src/sgml/mvcc.sgml
index bedd9a008d..4cd0465da1 100644
--- a/doc/src/sgml/mvcc.sgml
+++ b/doc/src/sgml/mvcc.sgml
@@ -422,6 +422,31 @@ COMMIT;
     <literal>11</literal>, which no longer matches the criteria.
    </para>
 
+   <para>
+    The <command>MERGE</command> allows the user to specify various combinations
+    of <command>INSERT</command>, <command>UPDATE</command> or
+    <command>DELETE</command> subcommands. A <command>MERGE</command> command
+    with both <command>INSERT</command> and <command>UPDATE</command>
+    subcommands looks similar to <command>INSERT</command> with an
+    <literal>ON CONFLICT DO UPDATE</literal> clause but does not guarantee
+    that either <command>INSERT</command> and <command>UPDATE</command> will occur.
+
+    If MERGE attempts an UPDATE or DELETE and the row is concurrently updated
+    but the join condition still passes for the current target and the current
+    source tuple, then MERGE will behave the same as the UPDATE or DELETE commands
+    and perform its action on the latest version of the row, using standard
+    EvalPlanQual. MERGE actions can be conditional, so conditions must be
+    re-evaluated on the latest row, starting from the first action.
+
+    On the other hand, if the row is concurrently updated or deleted so that
+    the join condition fails, then MERGE will execute a NOT MATCHED action, if it
+    exists and the AND WHEN qual evaluates to true.
+
+    If MERGE attempts an INSERT and a unique index is present and a duplicate
+    row is concurrently inserted then a uniqueness violation is raised. MERGE
+    does not attempt to avoid the ERROR by attempting an UPDATE.
+   </para>
+
    <para>
     Because Read Committed mode starts each command with a new snapshot
     that includes all transactions committed up to that instant,
@@ -900,7 +925,8 @@ ERROR:  could not serialize access due to read/write dependencies among transact
 
         <para>
          The commands <command>UPDATE</command>,
-         <command>DELETE</command>, and <command>INSERT</command>
+         <command>DELETE</command>, <command>INSERT</command> and
+         <command>MERGE</command>
          acquire this lock mode on the target table (in addition to
          <literal>ACCESS SHARE</literal> locks on any other referenced
          tables).  In general, this lock mode will be acquired by any
diff --git a/doc/src/sgml/plpgsql.sgml b/doc/src/sgml/plpgsql.sgml
index b9eb98cfd7..508566acec 100644
--- a/doc/src/sgml/plpgsql.sgml
+++ b/doc/src/sgml/plpgsql.sgml
@@ -1245,7 +1245,7 @@ EXECUTE format('SELECT count(*) FROM %I '
 </programlisting>
      Another restriction on parameter symbols is that they only work in
      <command>SELECT</command>, <command>INSERT</command>, <command>UPDATE</command>, and
-     <command>DELETE</command> commands.  In other statement
+     <command>DELETE</command> and <command>MERGE</command> commands.  In other statement
      types (generically called utility statements), you must insert
      values textually even if they are just data values.
     </para>
@@ -1520,6 +1520,7 @@ GET DIAGNOSTICS integer_var = ROW_COUNT;
           <listitem>
            <para>
             <command>UPDATE</command>, <command>INSERT</command>, and <command>DELETE</command>
+            and <command>MERGE</command>
             statements set <literal>FOUND</literal> true if at least one
             row is affected, false if no row is affected.
            </para>
diff --git a/doc/src/sgml/ref/allfiles.sgml b/doc/src/sgml/ref/allfiles.sgml
index c81c87ef41..7cd6ee85dc 100644
--- a/doc/src/sgml/ref/allfiles.sgml
+++ b/doc/src/sgml/ref/allfiles.sgml
@@ -159,6 +159,7 @@ Complete list of usable sgml source files in this directory.
 <!ENTITY load               SYSTEM "load.sgml">
 <!ENTITY lock               SYSTEM "lock.sgml">
 <!ENTITY move               SYSTEM "move.sgml">
+<!ENTITY merge              SYSTEM "merge.sgml">
 <!ENTITY notify             SYSTEM "notify.sgml">
 <!ENTITY prepare            SYSTEM "prepare.sgml">
 <!ENTITY prepareTransaction SYSTEM "prepare_transaction.sgml">
diff --git a/doc/src/sgml/ref/create_policy.sgml b/doc/src/sgml/ref/create_policy.sgml
index 2e1229c4f9..618dd45240 100644
--- a/doc/src/sgml/ref/create_policy.sgml
+++ b/doc/src/sgml/ref/create_policy.sgml
@@ -94,6 +94,13 @@ CREATE POLICY <replaceable class="parameter">name</replaceable> ON <replaceable
    exist, a <quote>default deny</quote> policy is assumed, so that no rows will
    be visible or updatable.
   </para>
+
+  <para>
+   No separate policy exists for <command>MERGE</command>. Instead policies
+   defined for <literal>SELECT</literal>, <literal>INSERT</literal>,
+   <literal>UPDATE</literal> and <literal>DELETE</literal> are applied
+   while executing MERGE, depending on the actions that are activated.
+  </para>
  </refsect1>
 
  <refsect1>
diff --git a/doc/src/sgml/ref/insert.sgml b/doc/src/sgml/ref/insert.sgml
index 62e142fd8e..da294aaa46 100644
--- a/doc/src/sgml/ref/insert.sgml
+++ b/doc/src/sgml/ref/insert.sgml
@@ -579,6 +579,13 @@ INSERT <replaceable>oid</replaceable> <replaceable class="parameter">count</repl
    is a partition, an error will occur if one of the input rows violates
    the partition constraint.
   </para>
+
+  <para>
+   You may also wish to consider using <command>MERGE</command>, since that
+   allows mixed <command>INSERT</command>, <command>UPDATE</command> and
+   <command>DELETE</command> within a single statement.
+   See <xref linkend="sql-merge"/>.
+  </para>
  </refsect1>
 
  <refsect1>
@@ -749,7 +756,9 @@ INSERT INTO distributors (did, dname) VALUES (10, 'Conrad International')
    Also, the case in
    which a column name list is omitted, but not all the columns are
    filled from the <literal>VALUES</literal> clause or <replaceable>query</replaceable>,
-   is disallowed by the standard.
+   is disallowed by the standard. If you prefer a more SQL Standard
+   conforming statement than <literal>ON CONFLICT</literal>, see
+   <xref linkend="sql-merge"/>.
   </para>
 
   <para>
